using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 坐席会员与项目楼关联
    /// </summary>
    public partial class T_Cus_Region_UserAccount_Map
    {
        public T_Cus_Region_UserAccount_Map()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("RegionId", "T_Cus_Region_UserAccount_Map");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int RegionId, int UserId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Cus_Region_UserAccount_Map");
            strSql.Append(" where RegionId=@RegionId and UserId=@UserId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@RegionId", SqlDbType.Int,4),
                    new SqlParameter("@UserId", SqlDbType.Int,4)            };
            parameters[0].Value = RegionId;
            parameters[1].Value = UserId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public bool Add(Model.T_Cus_Region_UserAccount_Map model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Cus_Region_UserAccount_Map(");
            strSql.Append("RegionId,UserId,CreateBy,CreateDateTime)");
            strSql.Append(" values (");
            strSql.Append("@RegionId,@UserId,@CreateBy,@CreateDateTime)");
            SqlParameter[] parameters = {
                    new SqlParameter("@RegionId", SqlDbType.Int,4),
                    new SqlParameter("@UserId", SqlDbType.Int,4),
                    new SqlParameter("@CreateBy", SqlDbType.NVarChar,50),
                    new SqlParameter("@CreateDateTime", SqlDbType.DateTime)};
            parameters[0].Value = model.RegionId;
            parameters[1].Value = model.UserId;
            parameters[2].Value = model.CreateBy;
            parameters[3].Value = model.CreateDateTime;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Cus_Region_UserAccount_Map model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Cus_Region_UserAccount_Map set ");
            strSql.Append("CreateBy=@CreateBy,");
            strSql.Append("CreateDateTime=@CreateDateTime");
            strSql.Append(" where RegionId=@RegionId and UserId=@UserId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@CreateBy", SqlDbType.NVarChar,50),
                    new SqlParameter("@CreateDateTime", SqlDbType.DateTime),
                    new SqlParameter("@RegionId", SqlDbType.Int,4),
                    new SqlParameter("@UserId", SqlDbType.Int,4)};
            parameters[0].Value = model.CreateBy;
            parameters[1].Value = model.CreateDateTime;
            parameters[2].Value = model.RegionId;
            parameters[3].Value = model.UserId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int RegionId, int UserId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Cus_Region_UserAccount_Map ");
            strSql.Append(" where RegionId=@RegionId and UserId=@UserId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@RegionId", SqlDbType.Int,4),
                    new SqlParameter("@UserId", SqlDbType.Int,4)            };
            parameters[0].Value = RegionId;
            parameters[1].Value = UserId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int UserId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Cus_Region_UserAccount_Map ");
            strSql.Append(" where UserId=@UserId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@UserId", SqlDbType.Int,4)
            };
            parameters[0].Value = UserId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Cus_Region_UserAccount_Map GetModel(int RegionId, int UserId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 RegionId,UserId,CreateBy,CreateDateTime from T_Cus_Region_UserAccount_Map ");
            strSql.Append(" where RegionId=@RegionId and UserId=@UserId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@RegionId", SqlDbType.Int,4),
                    new SqlParameter("@UserId", SqlDbType.Int,4)            };
            parameters[0].Value = RegionId;
            parameters[1].Value = UserId;

            Model.T_Cus_Region_UserAccount_Map model = new Model.T_Cus_Region_UserAccount_Map();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Cus_Region_UserAccount_Map DataRowToModel(DataRow row)
        {
            Model.T_Cus_Region_UserAccount_Map model = new Model.T_Cus_Region_UserAccount_Map();
            if (row != null)
            {
                if (row["RegionId"] != null && row["RegionId"].ToString() != "")
                {
                    model.RegionId = int.Parse(row["RegionId"].ToString());
                }
                if (row["UserId"] != null && row["UserId"].ToString() != "")
                {
                    model.UserId = int.Parse(row["UserId"].ToString());
                }
                if (row["CreateBy"] != null)
                {
                    model.CreateBy = row["CreateBy"].ToString();
                }
                if (row["CreateDateTime"] != null && row["CreateDateTime"].ToString() != "")
                {
                    model.CreateDateTime = DateTime.Parse(row["CreateDateTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select RegionId,UserId,CreateBy,CreateDateTime ");
            strSql.Append(" FROM T_Cus_Region_UserAccount_Map ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" RegionId,UserId,CreateBy,CreateDateTime ");
            strSql.Append(" FROM T_Cus_Region_UserAccount_Map ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Cus_Region_UserAccount_Map ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.UserId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Cus_Region_UserAccount_Map T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Cus_Region_UserAccount_Map";
			parameters[1].Value = "UserId";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
